searchNodes=[{"doc":"Joken.Hooks implementation for fetching Joken.Signers from public JWKS URLs.This hook is intended to be used when you are verifying a token is signed with a well known public key. It only overrides the before_verify/2 callback providing a Joken.Signer for the given token. It is important to notice this is not meant for use when GENERATING a token. So, using this hook with Joken.encode_and_sign function WILL NOT WORK!!!To use it, pass this hook to Joken either with the add_hook/2 macro or directly to each Joken function. Example:defmodule MyToken do use Joken.Config add_hook(JokenJwks, strategy: MyFetchingStrategy) # rest of your token config endOr:Joken.verify_and_validate(config, token, nil, context, [{Joken.Jwks, strategy: MyStrategy}])Fetching strategyVery rarely, your authentication server might rotate or block its keys. Key rotation is the process of issuing a new key that in time will replace the older key. This is security hygiene and should/might be a regular process.Sometimes it is important to block keys because they got leaked or for any other reason. Other times you simply don't control the authentication server and can't ensure the keys won't change. This is the most common scenario for this hook.In these cases (and some others) it is important to have a cache invalidation strategy: all your cached keys should be refreshed. Since the best strategy might differ for each use case, there is a behaviour that can be customized as the &quot;fetching strategy&quot;, that is: when to fetch and re-fetch keys. JokenJwks has a default strategy that tries to be smart and cover most use cases by default. It combines a time based state machine to avoid overflowing the system with re-fetching keys. If that is not a good option for your use case, it can still be configured. Please, see JokenJwks.SignerMatchStrategy or JokenJwks.DefaultStrategyTemplate docs for more information.","ref":"JokenJwks.html","title":"JokenJwks","type":"module"},{"doc":"","ref":"JokenJwks.html#log/3","title":"JokenJwks.log/3","type":"function"},{"doc":"A JokenJwks.SignerMatchStrategy template that has a window of time for refreshing its cache. This is a template and not a concrete implementation. You should use this module in order to use the default strategy.This implementation is a task that should be supervised. It loops on a time window checking whether it should re-fetch keys or not.Every time a bad kid is received it writes to an ets table a counter to 1. When the task loops, it polls for the counter value. If it is more than zero it starts re-fetching the cache. Upon successful fetching, it zeros the counter once again. This way we avoid overloading the JWKS server.It will try to fetch signers when supervision starts it. This can be a sync or async operation depending on the value of first_fetch_sync. It defaults to false. UsageThis strategy must be under your apps' supervision tree. It must be explicitly used under a module so that you can have more than one JWKS source.When using this strategy, there is an init_opts/1 callback that can be overridden. This is called upon supervision start. It should return a keyword list with all the options. This follows the standard practice of allowing a callback for using runtime configuration. It can override all other options as this has higher preference.ConfigurationOther than the init_opts/1 callback you can pass options through Mix.Config and when starting the supervisor. The order of preference in least significant order is:Per environment Mix.ConfigSupervisor child optionsinit_opts/1 callbackThe only mandatory option is jwks_url (binary()) that is, usually, a runtime parameter like a system environment variable. It is recommended to use the init_opts/1 callback.Other options are:time_interval (integer() - default 60_000 (1 minute)): time interval for polling if it is needed to re-fetch the keys;log_level (:none | :debug | :info | :warn | :error - default :debug): the level of log to use for events in the strategy like HTTP errors and so on. It is advised not to turn off logging in production;should_start (boolean() - default true): whether to start the supervised polling task. For tests, this should be false;first_fetch_sync (boolean() - default false): whether to fetch the first time synchronously or async;explicit_alg (String.t()): the JWS algorithm for use with the key. Overrides the one in the JWK;http_max_retries_per_fetch (pos_integer() - default 10): passed to Tesla.Middleware.Retry;http_delay_per_retry (pos_integer() - default 500): passed to Tesla.Middleware.Retry.Example usage:defmodule JokenExample.MyStrategy do use JokenJwks.DefaultStrategyTemplate def init_opts(opts) do url = # fetch url ... Keyword.merge(opts, jwks_url: url) end end defmodule JokenExample.Application do @doc false def start(_type, _args) do import Supervisor.Spec, warn: false children = [ {MyStrategy, time_interval: 2_000} ] opts = [strategy: :one_for_one] Supervisor.start_link(children, opts) end endThen on your token configuration module:defmodule MyToken do use Joken.Config add_hook(JokenJwks, strategy: MyStrategy) # rest of your token config end","ref":"JokenJwks.DefaultStrategyTemplate.html","title":"JokenJwks.DefaultStrategyTemplate","type":"module"},{"doc":"Makes a GET request to an OpenID Connect certificates endpoint.This must be a standard JWKS URI as per the specification here: https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadataThis uses the Tesla library to make it easy to test or change the adapter if wanted.See our tests for an example of mocking the HTTP fetching.","ref":"JokenJwks.HttpFetcher.html","title":"JokenJwks.HttpFetcher","type":"module"},{"doc":"Fetches the JWKS signers from the given url.This retries up to 10 times with a fixed delay of 500 ms until the server delivers an answer. We only perform a GET request that is idempotent.We use :hackney as it validates certificates automatically.","ref":"JokenJwks.HttpFetcher.html#fetch_signers/2","title":"JokenJwks.HttpFetcher.fetch_signers/2","type":"function"},{"doc":"Tesla Middleware for publishing telemetry events.This middleware reports status and request time/response useful for monitoring the JWKS provider.","ref":"JokenJwks.Middleware.Telemetry.html","title":"JokenJwks.Middleware.Telemetry","type":"module"},{"doc":"A strategy behaviour for using with JokenJwks.JokenJwks will call this for every token with a kid. It is the strategy's responsibility to handle caching and matching of the kid with its signers cache.See JokenJwks.DefaultStrategyTemplate for an implementation.","ref":"JokenJwks.SignerMatchStrategy.html","title":"JokenJwks.SignerMatchStrategy","type":"behaviour"},{"doc":"","ref":"JokenJwks.SignerMatchStrategy.html#c:match_signer_for_kid/2","title":"JokenJwks.SignerMatchStrategy.match_signer_for_kid/2","type":"callback"},{"doc":"JWKS (JSON Web Key Set)When using JWTs for digital signing we need a key to sign and verify the contents of the token. Many times the part that is doing signature verification is the same that does the signing and so, it posseses both the private and public key. Other times, this is not the case.When using an authentication server that is different than the &quot;business&quot; server, the later has no control about the keys being used to authenticate a request. On these cases, the authentication server publishes its own public key so that anyone can validate tokens that it has generated before with the matching private key.This scenario is common on delegated authentication as mentioned. One specification that uses this approach is OAuth2 with OpenID Connect. The auth server has a public configuration endpoint where there is plenty information about how to connect with the server. One such information is the JWKS (JSON Web Key Set): a list of public keys the server uses to generate signed tokens.Example of well known JWKS URIs:Google: https://www.googleapis.com/oauth2/v3/certsMicrosoft: https://login.microsoftonline.com/common/discovery/keys","ref":"introduction.html","title":"JWKS (JSON Web Key Set)","type":"extras"},{"doc":"If your server is using Joken 2 to validate tokens, then you can use this hook to retrieve the list of signers from a JWKS URI. This is how it happens:Build you token configuration (either with use Joken.Config or directly);Initialize your fetching strategy;Pass this hook to your verify call:If you are using Joken.Config then it's just a matter of add_hook(JokenJwks, strategy: &lt;&lt;YOUR STRATEGY&gt;&gt;);If you are calling Joken.verify_* directly, you can pass the hook as a last parameter.Remember that there can't be a default signer otherwise it will have precedence over this!","ref":"introduction.html#joken-jwks-hook","title":"JWKS (JSON Web Key Set) - Joken JWKS hook","type":"extras"},{"doc":"This hook will call the behaviour JokenJwks.SignerMatchstrategy for every token. It is the implementation job to decide how to choose a signer for the token. The only occasion where this will not call the behaviour is if the given token is not properly formed nor it contains a &quot;kid&quot; claim on its header. JWKS mandates this claim so that we know which key to use for verifying.A very naive approach of implementing the callback would be to fetch signers upon startup and then re-fetching everytime a token kid does not match with the loaded cache.This could potentially open an attack vector for massively hitting the authentication server. Of course, the auth server JWKS url is public and an attacker could just hit it directly, but it is wise to have some deffense machanism in place when developing your strategy.","ref":"introduction.html#architecture","title":"JWKS (JSON Web Key Set) - Architecture","type":"extras"},{"doc":"JokenJwks comes with a smart enough implementation that uses a time window approach for re-fetching signers. By default, it polls the cache state every minute to see if a bad kid was attempted. If so, it refetches the cache. So, it will fetch JWKS once every minute tops.","ref":"introduction.html#default-strategy-template","title":"JWKS (JSON Web Key Set) - Default Strategy Template","type":"extras"},{"doc":"Since the JWKS specification is just that, a specification, many servers might disagree on how to implement this. For example, Google specifies the &quot;alg&quot; claim on every key instance. Microsoft does not. Therefore we assume some interpretations:Every key must have a &quot;kid&quot; (even if there is only one key);We don't currently check for the &quot;use&quot; claim and so we might hit an encryption key (which will be parsed as well);If no &quot;alg&quot; claim is provided, then the user must pass the option &quot;explicit_alg&quot;.That's it for now :)","ref":"introduction.html#interpretation-of-the-jwks-rfc","title":"JWKS (JSON Web Key Set) - Interpretation of the JWKS RFC","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Changed(Emil Bostijancic) upgrades hackney dependency to 1.16.0 (#17)Updated depsFixed(@seancribbs) Address unmatched return warnings from Dialyzer (#16)","ref":"changelog.html#1-4-0-2020-09-27","title":"Changelog - [1.4.0] - 2020-09-27","type":"extras"},{"doc":"Fixed(@duzzifelipe) #13 fix: change fetch signers spec","ref":"changelog.html#1-3-1-2020-03-02","title":"Changelog - [1.3.1] - 2020-03-02","type":"extras"},{"doc":"Added(@duzzifelipe) #12 feat: telemetry middleware for tesla","ref":"changelog.html#1-3-0-2020-03-02","title":"Changelog - [1.3.0] - 2020-03-02","type":"extras"},{"doc":"Added(René Mygind Andersen) #7 Adds support for parsing JWKS returned with content-type 'applicat…Changed(@ltj) Use hackney v1.15.2","ref":"changelog.html#1-2-0-2019-11-08","title":"Changelog - [1.2.0] - 2019-11-08","type":"extras"},{"doc":"AddedOptions for explicitly telling which algorithm will use for the parsed signers;HTTP options for retry and adapter;Integration tests for Google and Microsoft JWKS endpoints.FixedFixed docs about how to use DefaultStrategyTemplate and Fixed spelling (#4 thanks to @bforchhammer)","ref":"changelog.html#1-1-0-2019-03-05","title":"Changelog - [1.1.0] - 2019-03-05","type":"extras"},{"doc":"AddedFirst version of the library with a default time window strategy for refetching signers.","ref":"changelog.html#1-0-0-2019-01-02","title":"Changelog - [1.0.0] - 2019-01-02","type":"extras"}]